package jlenses;
//Primer etapa de GLlessen
//Interfase grafica -GUI- >A<
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import gl4java.awt.*;
import gl4java.drawable.*;
import gl4java.*;
import gl4java.utils.glut.*;
import java.lang.*;

public class Glentes extends JFrame{
  JPanel P[] = new JPanel[8];
  JButton B[]=new JButton[12];
  Button B1[]=new Button[12];
  Checkbox C[]=new Checkbox[6];
  JComboBox CB[]=new JComboBox[6];
  JLabel L[]=new JLabel[10];
  JTextField F[]=new JTextField[19];
  JSlider S[]=new JSlider[17];
  JScrollBar S1[]=new JScrollBar[7];
  String models[]={"Model Menu","Chang Refsdal","Singular Isothermal Sphere","Nonsingular Isothermal Sphere","Transparent Sphere",
  "Elliptical","King","Truncated king","Hubble","De Vaucouleur","Spiral","Multipole","Rotation Lens","Double lens","Uniform Ring","Second Order","Elliptic King",
  "Elliptic Hubble","Elliptic NIS","Elliptic Plummer","Barkana"};
  String sources[]={"Source Menu","Filled Circle","Coloured Rings","Circle","Concentric Circles","Ellipse","Concentric Ellipses","Spiral","Pattern",
  "Random Pattern","Image File"};
  G2lentes g = new G2lentes();
  G3lentes IW = new G3lentes();
  G5lentes G5=new G5lentes();
  G6lentes G6=new G6lentes();
  G7lentes G7=new G7lentes();
  Eventos escu=new Eventos();
  double Y=0,X=0;
  static double GIF[][]=new double[8][1000];
  static int ff=0;
  int mod;
  Thread eje;
  public Glentes(){
    super("XFGL");
    Constru();
    setContentPane(P[5]);
    setSize(850,450);
    setLocation(0,50);
  }//Fin Glentes

  public void Constru(){
    P[0]=new JPanel();
    P[0].setLayout(new GridLayout(5,3));
    C[0]=new Checkbox("Source");
    P[0].add(C[0]);
    C[3]=new Checkbox("R_E");
    P[0].add(C[3]);
    B[4]=new JButton("Exit");
    P[0].add(B[4]);
    C[1]=new Checkbox("Images");
    P[0].add(C[1]);
    C[4]=new Checkbox("R plot");
    P[0].add(C[4]);
    B[5]=new JButton("Help");
    P[0].add(B[5]);
    C[2]=new Checkbox("Contour");
    P[0].add(C[2]);
    C[5]=new Checkbox("Time delay");
    P[0].add(C[5]);
    B[6]=new JButton("Save");
    P[0].add(B[6]);
    B[0]=new JButton("Image file");
    P[0].add(B[0]);
    B[2]=new JButton("OBIP");
    P[0].add(B[2]);
    B[7]=new JButton("Track");
    P[0].add(B[7]);
    B[1]=new JButton("Roots");
    P[0].add(B[1]);
    B[3]=new JButton("Fitting");
    P[0].add(B[3]);
    B[8]=new JButton("Invertion");
    P[0].add(B[8]);

    P[1]=new JPanel();
    P[1].setLayout(new GridLayout(3,1));

    CB[0]=new JComboBox(models);
    P[1].add(CB[0]);
    CB[1]=new JComboBox(sources);
    P[1].add(CB[1]);
    B[9]=new JButton("Image Window");
    P[1].add(B[9]);

    P[2]=new JPanel();
    P[2].setLayout(new GridLayout(1,17));
    P[3]=new JPanel();
    P[3].setLayout(new GridLayout(1,17));
    for(int nu=0;nu<16;nu++){
      F[nu]=new JTextField();
      P[2].add(F[nu]);
      F[nu].setEditable(false);
      S[nu]=new JSlider(1,0,100,0);
      P[3].add(S[nu]);
    }
    P[4]=new JPanel();
    P[4].setLayout(new BorderLayout());
    B[10]=new JButton("Model Parameters");
    P[4].add("North",B[10]);
    P[4].add("Center",P[2]);
    P[4].add("South",P[3]);
    P[5]=new JPanel();
    P[5].setLayout(new BorderLayout(10,3));
    P[5].add("East",P[0]);
    P[6]=new JPanel();
    P[6].setLayout(new GridLayout(1,2,10,0));
    P[7]=new JPanel();
    P[7].setLayout(new GridLayout(6,2));
    String lt[] = {"","","","","        X=","","","        Y=","",""};
    for(int nu=0;nu<10;nu++){
      L[nu]=new JLabel(lt[nu]);
      P[7].add(L[nu]);
      if(nu==4){
        F[17]= new JTextField(""+X);
        P[7].add(F[17]);}
      if(nu==7){
        F[18]= new JTextField(""+Y);
        P[7].add(F[18]);}
    }
    P[6].add(P[7]);
    P[6].add(P[1]);
    P[5].add("Center",P[6]);
    P[5].add("West",g);
    P[5].add("South",P[4]);
    B[11]=new JButton("GL Control Panel");
    B[11].setEnabled(false);
    P[5].add("North",B[11]);
    g.addMouseListener(escu);
    g.addMouseMotionListener(escu);
    F[17].addActionListener(escu);
    F[18].addActionListener(escu);
    for(int nu=0;nu<16;nu++){
      S[nu].addChangeListener(escu);
      F[nu].setVisible(false);
      S[nu].setVisible(false);
      if(nu<12)
      B[nu].addActionListener(escu);
      if(nu<6)
      C[nu].addItemListener(escu);
    }//For
    CB[0].addItemListener(escu);
    CB[1].addItemListener(escu);
    G5.B[0].addActionListener(escu);
    G5.B[4].addActionListener(escu);
    G6.B[0].addMouseListener(escu);
    G6.B[1].addActionListener(escu);
    addWindowListener(escu);
  }//Fin constru

  void SliderM(int n){
    double a = S[n].getValue();
    String out= IW.glc.F.Par[mod][n][0]+(a/100);
    F[n].setText(out);
    IW.glc.F.Par[mod][n][3]=""+(double)a/100;
    if(n==5)
            IW.drawsou("",(double)S[5].getValue()/100,0);
    IW.glc.repaint();
  }//SliderM

  void SliderS(){
        if(mod!=-1){
        int ma=IW.glc.F.NP[mod];
        for(int nu=0;nu<16;nu++){
                if(nu<ma){
                F[nu].setVisible(true);
                S[nu].setMinimum((int)(Double.parseDouble(IW.glc.F.Par[mod][nu][1])*100));
                S[nu].setMaximum((int)(Double.parseDouble(IW.glc.F.Par[mod][nu][2])*100));
            S[nu].setValue((int)(Double.parseDouble(IW.glc.F.Par[mod][nu][3])*100));
        S[nu].setVisible(true);
        SliderM(nu);}else{
        F[nu].setVisible(false);
              S[nu].setVisible(false);}
        }}

  }//SliderS
  void prueba(double a, int b){
    if(a>=-50 && a<=50){
      if(b==0){
                  g.X=60+a;
                  IW.glc.X=(a/50);
                  }
      if(b==1){
                  g.Y=75-a;
                  IW.glc.Y=(-a/50);
                  }
      L[9].setText("");
      g.repaint();
      IW.glc.repaint();
    }else{
      if(b==0) L[9].setText("X [-50,50]");
      if(b==1) L[9].setText("Y [-50,50]");
      }
  }//prueba

  void mov(double xi,double yi,double xf, double yf){
  double XM=xi,MM=0.001,M=(yf-yi)/(xf-xi);
                    if(xi>xf) MM=-MM;
                    IW.ho(xi,yi);
                    for(XM=xi;XM<=xf;XM=XM+MM){
                      IW.glc.gl.glClear(IW.glc.GL_COLOR_BUFFER_BIT | IW.glc.GL_DEPTH_BUFFER_BIT);
                      IW.glc.repaint();
                                  for(int jj=0;jj<10000;jj++);
                                    IW.ho(XM,M*XM+(yi-(M*xi)));
                                    IW.glc.D[1]=0;
                                    IW.glc.D[1]=1;
                                      /*g.repaint();
                                      repaint();*/
                  }
        }

 void fit(){
	 double best0=100,best1=100;
	 int bestpar0=0,bestpar1=0,lim=4,par[]={0,2,3,4,6,7,8,9,10,11,12};
	 if((IW.glc.F.NP[mod]-2)<6)
	 	lim=IW.glc.F.NP[mod]-2;

	 for(int ii=0; ii<Math.pow(10,lim);ii++){
		 String val=""+ii;
		 for(int k=val.length();k<(lim);k++)
			 val="0"+val;
		 for(int jj=0;jj<(lim);jj++){
			IW.glc.F.Par[mod][par[jj]][3]=""+((Integer.parseInt(""+val.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.1));

		 }
		 IW.glc.F.mod=mod;
		 double y1[][]=new double[G5.numi][2];
		 for(int jj=0;jj<G5.numi;jj++){
		 	IW.glc.F.lens_equation((G5.pimg[jj][0]/50),(G5.pimg[jj][1]/50));
		 	y1[jj][0]=IW.glc.F.y1;
		    y1[jj][1]=IW.glc.F.y2;
		 }
		 double cot=(Math.pow((y1[0][0]-y1[1][0]),2)+Math.pow((y1[0][1]-y1[1][1]),2)+Math.pow((y1[0][0]-y1[2][0]),2)+Math.pow((y1[0][1]-y1[2][1]),2)+Math.pow((y1[0][0]-y1[3][0]),2)+Math.pow((y1[0][1]-y1[3][1]),2)+Math.pow((y1[3][0]-y1[2][0]),2)+Math.pow((y1[3][1]-y1[2][1]),2)+Math.pow((y1[3][0]-y1[1][0]),2)+Math.pow((y1[3][1]-y1[1][1]),2)+Math.pow((y1[2][0]-y1[1][0]),2)+Math.pow((y1[2][1]-y1[1][1]),2))/6;
		 if(cot<best0){
			 best0=cot;
			 bestpar0=ii;
			}
	 }
	String val=""+bestpar0;
	for(int k=val.length();k<lim;k++)
		val="0"+val;
	for(int jj=0;jj<lim;jj++){
			IW.glc.F.Par[mod][par[jj]][3]=""+((Integer.parseInt(""+val.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.1));

	}
	 for(int ii=0; ii<Math.pow(10,lim);ii++){
			 String val1=""+ii;
			 for(int k=val1.length();k<lim;k++)
				 val1="0"+val1;
			 for(int jj=0;jj<lim;jj++){
				IW.glc.F.Par[mod][par[jj]][3]=""+((((Integer.parseInt(""+val.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.1))-(5*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.01)))+((Integer.parseInt(""+val1.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.01)));

			 }
			 IW.glc.F.mod=mod;
		 double y1[][]=new double[G5.numi][2];
		 for(int jj=0;jj<G5.numi;jj++){
		 	IW.glc.F.lens_equation((G5.pimg[jj][0]/50),(G5.pimg[jj][1]/50));
		 	y1[jj][0]=IW.glc.F.y1;
		    y1[jj][1]=IW.glc.F.y2;
		 }
		 double cot=(Math.pow((y1[0][0]-y1[1][0]),2)+Math.pow((y1[0][1]-y1[1][1]),2)+Math.pow((y1[0][0]-y1[2][0]),2)+Math.pow((y1[0][1]-y1[2][1]),2)+Math.pow((y1[0][0]-y1[3][0]),2)+Math.pow((y1[0][1]-y1[3][1]),2)+Math.pow((y1[3][0]-y1[2][0]),2)+Math.pow((y1[3][1]-y1[2][1]),2)+Math.pow((y1[3][0]-y1[1][0]),2)+Math.pow((y1[3][1]-y1[1][1]),2)+Math.pow((y1[2][0]-y1[1][0]),2)+Math.pow((y1[2][1]-y1[1][1]),2))/6;
			 if(cot<best1){
				 best1=cot;
				 bestpar1=ii;
				}
	 }
	 String val1=""+bestpar1;
	 System.out.println(" "+best1+" ("+bestpar0+","+bestpar1+")\n");
	 	for(int k=val1.length();k<lim;k++)
	 		val1="0"+val1;
	 	for(int jj=0;jj<lim;jj++){
			IW.glc.F.Par[mod][par[jj]][3]=""+((((Integer.parseInt(""+val.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.1))-(5*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.01)))+((Integer.parseInt(""+val1.charAt(jj))+1)*(Double.parseDouble(IW.glc.F.Par[mod][par[jj]][2])*0.01)));}
	SliderS();
        double y1[][]=new double[G5.numi][2],ym=100,xm=100;
                 for(int jj=0;jj<G5.numi;jj++){
                         IW.glc.F.lens_equation((G5.pimg[jj][0]/50),(G5.pimg[jj][1]/50));
                         y1[jj][0]=IW.glc.F.y1;
                         y1[jj][1]=IW.glc.F.y2;
                         if(y1[jj][0]<xm) xm=y1[jj][0];
                         if(y1[jj][1]<ym) ym=y1[jj][1];
                 }
                 prueba((xm*25),0);
                 F[17].setText(""+(xm*25));
                 prueba((ym*-25),1);
                 F[18].setText(""+(ym*-25));
	IW.glc.update(IW.glc.getGraphics());
 }//fitt

private class Eventos implements ActionListener,ChangeListener,MouseListener,MouseMotionListener, WindowListener, ItemListener{
  public void actionPerformed(ActionEvent evt){
    double a;
      if(evt.getSource()==F[17]){
        a=Double.parseDouble(F[17].getText());
        prueba(a,0);}
      if(evt.getSource()==F[18]){
        a=Double.parseDouble(F[18].getText());
        prueba(a,1);}
      if(evt.getSource()==B[4]){
        System.exit(0);}
      if(evt.getSource()==B[1]){
                if(IW.glc.D[7]==1) IW.glc.D[7]=0;
        else IW.glc.D[7]=1;
        IW.glc.repaint();}
      if(evt.getSource()==B[2]){
        G5.show();}
      if(evt.getSource()==B[7]){
        G6.show();}
      if(evt.getSource()==B[9]){
        if((IW.OIW%2)==0)
        	IW.show();
        else IW.hide();
        IW.OIW++;
      }
      if(evt.getSource()==B[3]){
		if(IW.glc.D[6]==1 && G5.numi!=0 ){
        	/*int jjj = 987;
        	String iii=""+jjj;
        	System.out.println("fitting "+iii.charAt(0));*/
        	fit();
        }

      }
      if(evt.getSource()==B[10]){
        for(int nu=0;nu<16;nu++){
          F[nu].setVisible(true);
          S[nu].setVisible(true);
        }//For
      }
      if(evt.getSource()==G5.B[0]){
        IW.glc.D[6]=1;
        IW.glc.repaint();
      }
      if(evt.getSource()==G5.B[4]){
        IW.glc.D[6]=0;
        IW.glc.repaint();
      }
      if(evt.getSource()==G6.B[1]){
        if((G7.OIW%2)==0){
        G7.show();
        G7.glc.repaint();}
        else G7.hide();
        G7.OIW++;

      }


  }
  public void stateChanged(ChangeEvent evt){
    for(int nu=0;nu<16;nu++){
      if(evt.getSource()==S[nu])
        SliderM(nu);
    }//For
  }//Funcion

  public void itemStateChanged(ItemEvent evt){
          if(evt.getSource()==CB[0]){
                  for(int nu=1;nu<21;nu++){
                        if(evt.getItem()==models[nu])
                                mod=nu-1;
                  }
                  SliderS();
                  IW.glc.mod=mod;
                  IW.glc.F.mod=mod;
                  IW.glc.repaint();
                }
          if(evt.getSource()==CB[1])
                  IW.drawsou((String)evt.getItem(),(double)S[5].getValue()/100,1);
          for(int nu=0;nu<6;nu++){
                  if(evt.getSource()==C[nu]){
                        if(C[nu].getState())
                                IW.glc.D[nu]=1;
                        else
                                IW.glc.D[nu]=0;
                        IW.glc.repaint();}
                }
          }
  public void mouseReleased(MouseEvent evt){
   double a=(g.X-60), b=(75-g.Y);
    if(a>=-50 && a<=50 && b>=-50 && b<=50){
      F[17].setText(""+a);
      F[18].setText(""+b);
      IW.ho(a,b);}
  }
  public void mousePressed(MouseEvent evt) {
    if(evt.getSource()==G6.B[0]){
        ff=0;
        double XPI=Double.parseDouble(G6.F[0].getText()),YPI=Double.parseDouble(G6.F[1].getText()),XPF=Double.parseDouble(G6.F[2].getText()),YPF=Double.parseDouble(G6.F[3].getText()),XM=XPI,MM=0.2,M=(YPF-YPI)/(XPF-XPI);
        IW.glc.D[7]=1;
        IW.glc.update(IW.glc.getGraphics());
        if(XPI>XPF) MM=-MM;
             for(XM=XPI;XM<=XPF;XM=XM+MM){
               g.X=XM+60;
               g.Y=75-(M*XM+(YPI-(M*XPI)));
               g.update(g.getGraphics());
               IW.glc.D[7]=1;
               IW.glc.X=XM/50;
               IW.glc.Y=(M*XM+(YPI-(M*XPI)))/(-50);
               IW.glc.update(IW.glc.getGraphics());
               for(int kk=0;kk<IW.glc.NRZ;kk++){
               	GIF[kk][ff]=IW.glc.RZ[kk][2]/IW.glc.cont3;
               }
               ff++;
             }
           IW.glc.update(IW.glc.getGraphics());

  }}
  public void mouseClicked(MouseEvent evt) {}
  public void mouseEntered(MouseEvent evt) {}
  public void mouseExited(MouseEvent evt) {}
  public void mouseDragged(MouseEvent evt) {
    double a=(g.X-60), b=(75-g.Y);
    if(a>=-50 && a<=50 && b>=-50 && b<=50){
      F[17].setText(""+a);
      F[18].setText(""+b);
      IW.ho(a,b);}
  }
  public void mouseMoved(MouseEvent evt) {}
  public void windowClosing(WindowEvent evt){
      System.exit(0);}
  public void windowDeactivated(WindowEvent evt){}
  public void windowActivated(WindowEvent evt){}
  public void windowDeiconified(WindowEvent evt){}
  public void windowIconified(WindowEvent evt){}
  public void windowClosed(WindowEvent evt){}
  public void windowOpened(WindowEvent evt){}
}//Fin eventos
}
